<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAlarmMessageResult_V5 ArrayType
 * @subpackage Arrays
 */
class ArrayOfAlarmMessageResult_V5 extends AbstractStructArrayBase
{
    /**
     * The AlarmMessageResult_V5
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AlarmMessageResult_V5[]
     */
    public $AlarmMessageResult_V5;
    /**
     * Constructor method for ArrayOfAlarmMessageResult_V5
     * @uses ArrayOfAlarmMessageResult_V5::setAlarmMessageResult_V5()
     * @param \StructType\AlarmMessageResult_V5[] $alarmMessageResult_V5
     */
    public function __construct(array $alarmMessageResult_V5 = array())
    {
        $this
            ->setAlarmMessageResult_V5($alarmMessageResult_V5);
    }
    /**
     * Get AlarmMessageResult_V5 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AlarmMessageResult_V5[]|null
     */
    public function getAlarmMessageResult_V5()
    {
        return isset($this->AlarmMessageResult_V5) ? $this->AlarmMessageResult_V5 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAlarmMessageResult_V5 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAlarmMessageResult_V5 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAlarmMessageResult_V5ForArrayConstraintsFromSetAlarmMessageResult_V5(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAlarmMessageResult_V5AlarmMessageResult_V5Item) {
            // validation for constraint: itemType
            if (!$arrayOfAlarmMessageResult_V5AlarmMessageResult_V5Item instanceof \StructType\AlarmMessageResult_V5) {
                $invalidValues[] = is_object($arrayOfAlarmMessageResult_V5AlarmMessageResult_V5Item) ? get_class($arrayOfAlarmMessageResult_V5AlarmMessageResult_V5Item) : sprintf('%s(%s)', gettype($arrayOfAlarmMessageResult_V5AlarmMessageResult_V5Item), var_export($arrayOfAlarmMessageResult_V5AlarmMessageResult_V5Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AlarmMessageResult_V5 property can only contain items of type \StructType\AlarmMessageResult_V5, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AlarmMessageResult_V5 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AlarmMessageResult_V5[] $alarmMessageResult_V5
     * @return \ArrayType\ArrayOfAlarmMessageResult_V5
     */
    public function setAlarmMessageResult_V5(array $alarmMessageResult_V5 = array())
    {
        // validation for constraint: array
        if ('' !== ($alarmMessageResult_V5ArrayErrorMessage = self::validateAlarmMessageResult_V5ForArrayConstraintsFromSetAlarmMessageResult_V5($alarmMessageResult_V5))) {
            throw new \InvalidArgumentException($alarmMessageResult_V5ArrayErrorMessage, __LINE__);
        }
        if (is_null($alarmMessageResult_V5) || (is_array($alarmMessageResult_V5) && empty($alarmMessageResult_V5))) {
            unset($this->AlarmMessageResult_V5);
        } else {
            $this->AlarmMessageResult_V5 = $alarmMessageResult_V5;
        }
        return $this;
    }
    /**
     * Add item to AlarmMessageResult_V5 value
     * @throws \InvalidArgumentException
     * @param \StructType\AlarmMessageResult_V5 $item
     * @return \ArrayType\ArrayOfAlarmMessageResult_V5
     */
    public function addToAlarmMessageResult_V5(\StructType\AlarmMessageResult_V5 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AlarmMessageResult_V5) {
            throw new \InvalidArgumentException(sprintf('The AlarmMessageResult_V5 property can only contain items of type \StructType\AlarmMessageResult_V5, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AlarmMessageResult_V5[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AlarmMessageResult_V5|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AlarmMessageResult_V5|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AlarmMessageResult_V5|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AlarmMessageResult_V5|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AlarmMessageResult_V5|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AlarmMessageResult_V5
     */
    public function getAttributeName()
    {
        return 'AlarmMessageResult_V5';
    }
}
